image: node:latest

stages:
  - build
  - deploy
  - accessibility
  - manual

cache:
  paths:
    - node_modules/
    - .cache/
    - public/

include:
  - template: "Verify/Accessibility.gitlab-ci.yml"

variables:
  a11y_urls: "http://accessibility-demo-$CI_COMMIT_REF_SLUG.surge.sh"

build_site:
  stage: build
  only:
    - main
    - merge_requests
  script:
    - yarn install
    - yarn run build
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
  artifacts:
    paths:
      - ./public

deploy_review:
  stage: deploy
  needs:
    - build_site
  only:
    - merge_requests
  script:
    - node_modules/.bin/surge ./public --domain accessibility-demo-$CI_COMMIT_REF_SLUG.surge.sh
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: http://accessibility-demo-$CI_COMMIT_REF_SLUG.surge.sh
    on_stop: stop_review

stop_review:
  stage: manual
  needs:
    - deploy_review
  only:
    - merge_requests
  script:
    - node_modules/.bin/surge teardown accessibility-demo-$CI_COMMIT_REF_SLUG.surge.sh
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
